part of reflector.source;

class _ReflectingVisitor extends GeneralizingAstVisitor {
  final Options _options;
  final results = <Metadata> [];

  _ReflectingVisitor(this._options);

  @override
  visitClassDeclaration(ClassDeclaration clazz) {
    if (_options.withAnnotations.isNotEmpty) {
      // TODO: Make this better, tighter, not just string based.
      final filters = _options.withAnnotations.map((t) {
        return MirrorSystem.getName(reflectType(t).simpleName);
      });
      final metadata = clazz.metadata.map((m) => m.name.name);
      if (!filters.every(metadata.contains)) return;
    }
    final annotations = clazz.metadata.map((m) {
      return new AnnotationInfo(new Symbol(m.name.name), null);
    }).toList(growable: false);
    results.add(new ClassInfo(
        new Symbol(clazz.name.name),
        annotations: annotations));
  }
}
