library reflector.static;

import 'package:reflector/src/interfaces.dart';

class StaticReflector implements Reflector {
  final Map<Type, Metadata> _metadata;

  StaticReflector(this._metadata);

  @override
  List<Metadata> reflect([Options options = const Options()]) {
    var metadata = _metadata.values;
    if (options.withAnnotations.isNotEmpty) {
      metadata = metadata.where((m) {
        if (m is ClassInfo) {
          final annotations = (m as ClassInfo).annotations.map((a) => a.type);
          return options.withAnnotations.every(annotations.contains);
        } else {
          throw new UnsupportedError('Invalid type: ${m.runtimeType}');
        }
      });
    }
    return metadata.toList(growable: false);
  }
}
